import 'package:niralanlayout/utils/settings_persistence_utils.dart';
import 'package:shared_preferences/shared_preferences.dart';

class LocalStorageSettingsPersistenceUtils extends SettingsPersistenceUtils {
  final Future<SharedPreferences> instanceFuture =
      SharedPreferences.getInstance();

  @override
  Future<bool> getMusicOn() async {
    final prefs = await instanceFuture;
    return prefs.getBool('musicOn') ?? true;
  }

  @override
  Future<bool> getMuted({required bool defaultValue}) async {
    final prefs = await instanceFuture;
    return prefs.getBool('mute') ?? defaultValue;
  }

  @override
  Future<bool> getReviewStatus() async {
    final prefs = await instanceFuture;
    return prefs.getBool('REVIEW_STATUS') ?? false;
  }

  @override
  Future<int> getLevel() async {
    final prefs = await instanceFuture;
    return prefs.getInt('Level') ?? 1;
  }

  @override
  Future<bool> getSoundsOn() async {
    final prefs = await instanceFuture;
    return prefs.getBool('soundsOn') ?? true;
  }

  @override
  Future<void> saveMusicOn(bool value) async {
    final prefs = await instanceFuture;
    await prefs.setBool('musicOn', value);
  }

  @override
  Future<void> saveMuted(bool value) async {
    final prefs = await instanceFuture;
    await prefs.setBool('mute', value);
  }

  @override
  Future<void> saveReviewStatus(bool value) async {
    final prefs = await instanceFuture;
    await prefs.setBool('REVIEW_STATUS', value);
  }

  @override
  Future<void> saveLevel(int value) async {
    final prefs = await instanceFuture;
    await prefs.setInt('Level', value);
  }

  @override
  Future<void> saveSoundsOn(bool value) async {
    final prefs = await instanceFuture;
    await prefs.setBool('soundsOn', value);
  }
}
