import 'package:flutter/widgets.dart';
import 'package:provider/provider.dart';

class AppLifecycleWidget extends StatefulWidget {
  final Widget child;

  const AppLifecycleWidget({required this.child, super.key});

  @override
  State<AppLifecycleWidget> createState() => AppLifecycleWidgetState();
}

class AppLifecycleWidgetState extends State<AppLifecycleWidget>
    with WidgetsBindingObserver {
  final ValueNotifier<AppLifecycleState> lifecycleListenable =
      ValueNotifier(AppLifecycleState.inactive);

  @override
  Widget build(BuildContext context) {
    return InheritedProvider<ValueNotifier<AppLifecycleState>>.value(
      value: lifecycleListenable,
      child: widget.child,
    );
  }

  @override
  void didChangeAppLifecycleState(AppLifecycleState state) {
    lifecycleListenable.value = state;
  }

  @override
  void dispose() {
    WidgetsBinding.instance.removeObserver(this);
    super.dispose();
  }

  @override
  void initState() {
    super.initState();
    WidgetsBinding.instance.addObserver(this);
  }
}
