import 'package:flutter/material.dart';

class OtherGameWidget extends StatelessWidget {
  final String fontFamily;
  final Color fontColor;
  final double fontSize;
  final Color secondaryFontColor;
  final String squareBox;
  final List<dynamic> otherGamesData;
  final Function(String) onTap;

  OtherGameWidget({
    required this.fontFamily,
    required this.squareBox,
    required this.fontColor,
    required this.fontSize,
    required this.secondaryFontColor,
    required this.otherGamesData,
    required this.onTap,
  });

  @override
  Widget build(BuildContext context) {
    return Column(
      mainAxisAlignment: MainAxisAlignment.center,
      crossAxisAlignment: CrossAxisAlignment.center,
      children: [
        Center(
          child: Text(
            'OTHER GAMES',
            style: TextStyle(
              fontFamily: fontFamily,
              fontSize: 20,
              color: secondaryFontColor,
            ),
          ),
        ),
        Container(
          height: 80,
          margin: EdgeInsets.only(left: 8, right: 8),
          width: double.infinity,
          child: ListView.builder(
            itemCount: otherGamesData.length,
            scrollDirection: Axis.horizontal,
            itemBuilder: (context, index) {
              var item = otherGamesData[index];
              return InkResponse(
                onTap: () => onTap(item.key),
                child: Container(
                  margin: EdgeInsets.all(5),
                  alignment: Alignment.center,
                  child: Stack(
                    fit: StackFit.loose,
                    alignment: AlignmentDirectional.center,
                    children: [
                      Image.asset(
                        squareBox,
                        fit: BoxFit.fill,
                      ),
                      Padding(
                        padding: EdgeInsets.all(5),
                        child: Image.asset(
                          item.src,
                          fit: BoxFit.fill,
                        ),
                      ),
                    ],
                  ),
                ),
              );
            },
          ),
        ),
      ],
    );
  }
}
